
#include <ESP8266WiFi.h>
#include "DHT.h"
// Parameter fuer Temperaturskript, ggf. anpassen
#define MY_DELAY 60000          //Anzahl Millisekunden 60000 = 1 Minute);
                                 
#define MY_WLAN_SSID "Infma-Ut-AP1"  //SSID des verwendeten WLANs, 
                                 
#define MY_WLAN_PSK    "raspberry"    // WLAN-Pre-Shared-Key
#define MY_DEST_SRV_IP "192.168.251.228"   // IP oder DNS-Name des      
                                             
#define MY_DEST_SRV_PORT 8080                 // Phant default port = 8080
#define MY_PHANT_PUBLIC_KEY   "xeooOobrbwslOjJm9NkohqJD112" // Phant public key
#define MY_PHANT_PRIVATE_KEY  "gGnnrn8L8ehmWveYK2y4FwK6ppq" // Phant private key
#define MY_PHANT_PARAM_NAME   "ts" // Name des Parameters, der in Phant 
                                      
//DHT-Sensor Objekt erzeugen: GPIO-Pin (0 oder 2), Sensor (DHT11 oder DHT22), Frequenz-Faktor (spezifisch für ESP8266)
DHT dht(2, DHT11, 15); 
// Funktion um die Dezimalstellen eines float-Wertes zu ermitteln
long getDec(float val){
  long dec = 1000*(val-int(val)); 
  if(dec>0)return(dec);
  else if(dec<0)return((-1)*dec);
  else return(0);
}

void setup() {
  Serial.begin(115200);
  delay(10);

  // Sensor initialisieren
  dht.begin();

  Serial.println();
  Serial.println();
  Serial.print("Verbinden ");

  // Mit dem WLAN verbinden
  WiFi.begin(MY_WLAN_SSID, MY_WLAN_PSK);
  //Auf Verbindung warten
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println();
  Serial.println("Verbunden!");  
  Serial.print("IP: ");
  Serial.println(WiFi.localIP());
}

void loop() {
    // Eine Minute warten 
  delay(MY_DELAY);      


  Serial.println("Sensordaten lesen...");

  //Sensordaten lesen und in String umwandeln
  float h = dht.readHumidity(); //optional auch Luftfeuchtigkeit
  float t = dht.readTemperature();
  if (isnan(h) || isnan(t)) { //wenn NULL (d. h. kein gültiger Messwert)
    h=-255;                   //...dann Wert -255 zuweisen
    t=-255;
  }
  String hs = String(int(h))+ "."+String(getDec(h));
  String ts = String(int(t))+ "."+String(getDec(t));

  Serial.println("Verbinde...");

  WiFiClient client;
  if (!client.connect(MY_DEST_SRV_IP,MY_DEST_SRV_PORT)) {
    Serial.println("Verbindung fehlgeschlagen!");
    return;
  }

  // URL mit Daten und Keys bilden
  String url = "/input/";
  url = url + MY_PHANT_PUBLIC_KEY + "?private_key=" +     
        MY_PHANT_PRIVATE_KEY + "&" + MY_PHANT_PARAM_NAME + "=" +ts;
  Serial.println("Öffne: " + url);
  // Daten an Server senden
  client.print("GET "+ url + " HTTP/1.1\r\nHost: " + MY_DEST_SRV_IP + 
               "\r\nConnection: close\r\n\r\n");
  delay(10);
  // Antwort des Servers lesen
  while(client.available()){
    String line = client.readStringUntil('\r');
    Serial.print(line);
  }
  Serial.println();
  Serial.println("Verbindung wird geschlossen.");
   // Wenn die loop-Funktion endet, wird das client-Objekt
   // automatisch zerstört und die Verbindung wird beendet.
}

